aboutsummaryrefslogtreecommitdiff
path: root/paludis/repositories/e/ebuild/exheres-0/builtin_initmisc.bash
diff options
context:
space:
mode:
authorAvatar Ciaran McCreesh <ciaran.mccreesh@googlemail.com> 2008-03-05 10:49:08 +0000
committerAvatar Ciaran McCreesh <ciaran.mccreesh@googlemail.com> 2008-03-05 10:49:08 +0000
commita814a9530164c0214a952654a864e0ae516c1f08 (patch)
tree02ab544b8b31f6ec19001666107ef21375532d05 /paludis/repositories/e/ebuild/exheres-0/builtin_initmisc.bash
parent14b6afbb966443b3fed7a1370773d3160b4d531b (diff)
downloadpaludis-a814a9530164c0214a952654a864e0ae516c1f08.tar.gz
paludis-a814a9530164c0214a952654a864e0ae516c1f08.tar.xz
Add initmisc, killoldmisc, tidyupmisc too
Diffstat (limited to 'paludis/repositories/e/ebuild/exheres-0/builtin_initmisc.bash')
-rw-r--r--paludis/repositories/e/ebuild/exheres-0/builtin_initmisc.bash84
1 files changed, 84 insertions, 0 deletions
diff --git a/paludis/repositories/e/ebuild/exheres-0/builtin_initmisc.bash b/paludis/repositories/e/ebuild/exheres-0/builtin_initmisc.bash
new file mode 100644
index 000000000..11de213ca
--- /dev/null
+++ b/paludis/repositories/e/ebuild/exheres-0/builtin_initmisc.bash
@@ -0,0 +1,84 @@
+#!/bin/bash
+# vim: set sw=4 sts=4 et :
+
+# Copyright (c) 2006, 2007, 2008 Ciaran McCreesh
+#
+# This file is part of the Paludis package manager. Paludis is free software;
+# you can redistribute it and/or modify it under the terms of the GNU General
+# Public License, version 2, as published by the Free Software Foundation.
+#
+# Paludis is distributed in the hope that it will be useful, but WITHOUT ANY
+# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
+# details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
+# Place, Suite 330, Boston, MA 02111-1307 USA
+
+builtin_initmisc()
+{
+ local a
+ for a in PALUDIS_NON_EMPTY_VARIABLES ${PALUDIS_NON_EMPTY_VARIABLES} ; do
+ [[ -z "${!a}" ]] && die "\$${a} unset or empty"
+ declare -r ${a}="${!a}"
+ done
+
+ for a in ${PALUDIS_DIRECTORY_VARIABLES} ; do
+ [[ -d "${!a}" ]] || die "\$${a} (\"${!a}\") not a directory"
+ done
+
+ for a in ${PALUDIS_DIRECTORY_IF_EXISTS_VARIABLES} ; do
+ [[ -e "${!a}" ]] && [[ ! -d "${!a}" ]] && \
+ die "\$${a} (\"${!a}\") exists but is not a directory"
+ done
+
+ for a in PALUDIS_TMPDIR ; do
+ if ! [[ -d "${!a}" ]] ; then
+ PALUDIS_EXTRA_DIE_MESSAGE="
+!!! '${!a}' should be a directory, but does not exist. For,
+!!! security reasons, Paludis will not try to create this directory
+!!! automatically. Please create it by hand and give it appropriate
+!!! permissions. Typically you should use:
+!!! mkdir ${!a}
+!!! chgrp ${PALUDIS_REDUCED_GID} ${!a}
+!!! chmod g+rwx ${!a}
+!!! chmod +s ${!a}
+!!! although other values may be more appropriate for your system.
+"
+ die "\$${a} (\"${!a}\") not a directory"
+ fi
+ done
+
+ if [[ -e "${PALUDIS_TMPDIR}/${CATEGORY}/${PF}-misc" ]] ; then
+ if type -p chflags &>/dev/null; then
+ chflags -R 0 "${PALUDIS_TMPDIR}/${CATEGORY}/${PF}-misc" || die "Couldn't remove flags from workdir"
+ fi
+ rm -fr "${PALUDIS_TMPDIR}/${CATEGORY}/${PF}-misc" || die "Couldn't remove previous work"
+ fi
+
+ export T="${PALUDIS_TMPDIR}/${CATEGORY}/${PF}-misc/temp/"
+ mkdir -p "${T}" || die "Couldn't create \$T (\"${T}\")"
+ declare -r T="${T}"
+ export HOME="${T}"
+ export TMPDIR="${T}"
+}
+
+exheres_internal_initmisc()
+{
+ if hasq "initmisc" ${RESTRICT} ; then
+ ebuild_section "Skipping builtin_initmisc (RESTRICT)"
+ elif hasq "initmisc" ${SKIP_FUNCTIONS} ; then
+ ebuild_section "Skipping builtin_initmisc (SKIP_FUNCTIONS)"
+ else
+ ebuild_section "Starting builtin_initmisc"
+ builtin_initmisc
+ ebuild_section "Done builtin_initmisc"
+ fi
+}
+
+ebuild_f_initmisc()
+{
+ exheres_internal_initmisc ""
+}
+